#include <stdio.h>
#include <stdlib.h>

struct node {
	int data;
	struct node *next;
};

struct node* BuildOneTwoThree() {
	struct node* first = NULL;
	struct node* second = NULL;
	struct node* third = NULL;
	
	first = malloc(sizeof(struct node)); // allocate 3 nodes in the heap
	second = malloc(sizeof(struct node));
	third = malloc(sizeof(struct node));
	
	first->data = 1; 
	first->next = second; 
	second->data = 2; 
	second->next = third;
	third->data = 3; 
	third->next = NULL;

	return first;
}

int length(struct node* head) {
	struct node* current = head;
	int count = 0;
	while (current != NULL) {
		count++;
		current = current->next;
	}
	return count;
}

void print(struct node *runner){
	printf("\nPrinting List...\n");
	while(runner != NULL){
		printf("%d | ", runner->data);
		printf("%p -> ", runner->next);

		runner = runner->next;
	}
	printf("NULL\n");
}

struct node * insert_at_end(struct node * head, int data){
	struct node * runner = head;
	struct node * newNode = NULL;

	newNode = (struct node *) malloc(sizeof(struct node));
	if(newNode == NULL){
		fprintf(stderr, "No memory available on heap");
		exit(1);
	}
	newNode->data = data;
	newNode->next = NULL;

	//If list is empty, return newNode as head
	if(runner == NULL){
		return newNode;
	}

	//Make runner point to the last node
	while(runner->next != NULL)
		runner = runner->next;

	runner->next = newNode;

	return head;
}

int main(){

	struct node * head = NULL;
	head = BuildOneTwoThree();

	//printf("%d\n", head->next->data);

	printf("Length of the list is %d", length(head));

	print(head);

	
	head = insert_at_end(head, 100);
	head = insert_at_end(head, 101);

	print(head);
	

	return 0;
}

